# Angular2-Carousel

[![npm](https://img.shields.io/badge/npm-0.0.1-yellow.svg?style=flat)](https://www.npmjs.com/package/angular2-carousel) [![npm](https://img.shields.io/badge/build-passed-brightgreen.svg?style=flat)](https://www.npmjs.com/package/angular2-carousel)

> this is a smart library to create a carousel 

##Install
You can install the package from our npm package
```
 npm install --save ng2-carrousel
```

##Usage
First tou need to provide the CarouselModule to your desired Module 

```
import {CarouselModule} from "angular2-carousel";

// In your App's module or Custom Module:
@NgModule({
    imports: [
       CarouselModule
    ]
})
```

Now, you can use CarouselModule as follow:

```
<carousel-component >
    <div class=".item-carousel">a</div>
    <div class=".item-carousel">
        <div class="b">
            <img/>
            .
            .
            .
        </div>
    </div>
    <div class=".item-carousel">c</div>
    <div class=".item-carousel">d</div>
</carousel-component>
```


##Documentation
###Inputs (Properties)

| Parameter | Type | Default | Description |
| ------ | ------ | ------ | ------ |
| morePairSlides | number | 0 | Add slide carousel in both sides |
| angle | number | 45 | Angle to distribute the carousel |
| ratioScale | number | 1 | Carousel scale ratio |
| margin | number | 0 | Margin to separate between carousel slides  |
| perspective | number | 2000 | Perspective to show the carousel slide |
| timeToSlide | number | 300 | Time (in ms) to transalte to carousel slide if transition isn't complete |
| lockSlides | boolean | false | Block the swiping |
| initialSlide | number | 0 | Index number on initial carrousel |

###Outputs (Events)

| Event | Description |
| ------ | ------ |
| onSlideChangeStart | Event will be fired when slide change start |
| onSlideChangeEnd | Event will be fired when slide change finish |
| onSlideNextStart | Event will be fired when change start to slide to next direction |
| onSlideNextEnd | Event will be fired when change finish to slide to next direction |
| onSlidePrevStart | Event will be fired when change start to slide to prev direction |
| onSlidePrevEnd | Event will be fired when change end to slide to prev direction |
| onTouchMove | Event will be fired when user move the carousel|
| onTouchStart | Event will be fired when user start to move the carousel |
| onTouchEnd | Event will be fired when user finish to move the carousel |
| onTransitionStart | Event will be fired when transition between slides carousel start |
| onTransitionEnd | Event will be fired when transition between slides carousel end |


###Author
Alex Marcos Gutierrez
###License
MIT