(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('hammerjs'), require('@angular/platform-browser')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/common', 'hammerjs', '@angular/platform-browser'], factory) :
    (factory((global.ng = global.ng || {}, global.ng.carrouselModule = global.ng.carrouselModule || {}),global.ng.core,global.ng.common,global.hammerjs,global.ng['platform-browser']));
}(this, (function (exports,_angular_core,_angular_common,Hammer,_angular_platformBrowser) { 'use strict';

/**
 * :tmtfactory) © 2017
 * Alex Marcos <alejandro.marcos@tmtfactory.com>
 * @ignore
 */
var Carousel = /** @class */ (function () {
    function Carousel() {
        this._currdeg = 0;
        this._totalItems = 0;
        this._maxSize = 0;
        this._maxDegree = 0;
        this._totalWidth = 0;
        this._items = [];
        this._degreesSlides = [];
        this._currentIndex = 0;
        this._lastIndex = -1;
        this._lockSlides = false;
    }
    Object.defineProperty(Carousel.prototype, "id", {
        get: function () {
            return this._id;
        },
        set: function (value) {
            this._id = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "currdeg", {
        get: function () {
            return this._currdeg;
        },
        set: function (value) {
            this._currdeg = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "totalItems", {
        get: function () {
            return this._totalItems;
        },
        set: function (value) {
            this._totalItems = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "maxSize", {
        get: function () {
            return this._maxSize;
        },
        set: function (value) {
            this._maxSize = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "maxDegree", {
        get: function () {
            return this._maxDegree;
        },
        set: function (value) {
            this._maxDegree = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "totalWidth", {
        get: function () {
            return this._totalWidth;
        },
        set: function (value) {
            this._totalWidth = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "items", {
        get: function () {
            return this._items;
        },
        set: function (value) {
            this._items = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "degreesSlides", {
        get: function () {
            return this._degreesSlides;
        },
        set: function (value) {
            this._degreesSlides = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "currentIndex", {
        get: function () {
            return this._currentIndex;
        },
        set: function (value) {
            this._currentIndex = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "lockSlides", {
        get: function () {
            return this._lockSlides;
        },
        set: function (value) {
            this._lockSlides = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Carousel.prototype, "lastIndex", {
        get: function () {
            return this._lastIndex;
        },
        set: function (value) {
            this._lastIndex = value;
        },
        enumerable: true,
        configurable: true
    });
    return Carousel;
}());

var __decorate$1 = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
/**
 * :tmtfactory) © 2017
 * Alex Marcos <alejandro.marcos@tmtfactory.com>
 * @ignore
 */
var CarouselComponent = /** @class */ (function () {
    function CarouselComponent() {
        this.carousel = new Carousel();
        this.morePairSlides = 2;
        this.angle = 45;
        this.ratioScale = 1;
        this.margin = 20;
        this.perspective = 2000;
        this.endInSlide = true;
        this.timeToSlide = 300;
        this.lockSlides = false;
        this.initialSlide = 0;
        this.onSlideChangeStart = new _angular_core.EventEmitter();
        this.onSlideChangeEnd = new _angular_core.EventEmitter();
        this.onSlideNextStart = new _angular_core.EventEmitter();
        this.onSlideNextEnd = new _angular_core.EventEmitter();
        this.onSlidePrevStart = new _angular_core.EventEmitter();
        this.onSlidePrevEnd = new _angular_core.EventEmitter();
        this.onTouchMove = new _angular_core.EventEmitter();
        this.onTouchStart = new _angular_core.EventEmitter();
        this.onTouchEnd = new _angular_core.EventEmitter();
        this.onTransitionStart = new _angular_core.EventEmitter();
        this.onTransitionEnd = new _angular_core.EventEmitter();
    }
    CarouselComponent.prototype.ngOnInit = function () {
    };
    CarouselComponent.prototype.ngAfterViewInit = function () {
        this.configPlugin();
        console.log(this);
    };
    CarouselComponent.prototype.slideNext = function () {
        if (this.checkLimitsCarrousel(this.carousel.currentIndex + 1)) {
            this.moveSlideTo(++this.carousel.currentIndex);
        }
    };
    CarouselComponent.prototype.slidePrev = function () {
        if (this.checkLimitsCarrousel(this.carousel.currentIndex - 1)) {
            this.moveSlideTo(--this.carousel.currentIndex);
        }
    };
    CarouselComponent.prototype.slideTo = function (index) {
        if (this.checkLimitsCarrousel(index)) {
            this.carousel.currentIndex = index;
            this.moveSlideTo(this.carousel.currentIndex);
        }
    };
    CarouselComponent.prototype.update = function () {
        this.carousel = new Carousel;
        this.configPlugin();
    };
    CarouselComponent.prototype.configPlugin = function () {
        this.setPerspectiveContainer();
        this.carousel.items = Array.from(this.carouselElm.nativeElement.getElementsByClassName("item-carousel"));
        this.carousel.totalItems = this.carousel.items.length;
        this.getmaxSizes();
        this.carousel.totalWidth = this.carousel.items.length * this.carousel.maxSize;
        this.carousel.lockSlides = this.lockSlides;
        this.setDegreesOnSlides();
        this.manageEvents();
        this.initSlidesOn();
        this.updateCssShowSlides();
    };
    CarouselComponent.prototype.initSlidesOn = function () {
        if (this.initialSlide >= 0 && this.initialSlide < this.carousel.items.length) {
            this.carousel.currentIndex = this.initialSlide;
            var newDeg = this.carousel.currentIndex * this.angle;
            this.setNewDeg(-newDeg);
            this.setTransformCarrousel(-newDeg);
        }
    };
    CarouselComponent.prototype.rotate = function (e) {
        this.setNewDeg(this.carousel.currdeg + e.velocity);
        this.moveCarrousel(this.carousel.currdeg);
        if (e.isFinal) {
            if (this.endInSlide) {
                this.moveSlideTo(this.carousel.currentIndex);
            }
        }
    };
    CarouselComponent.prototype.setNewDeg = function (newDeg) {
        this.carousel.currdeg = newDeg;
        if (this.carousel.currdeg > 0) {
            this.carousel.currdeg = 0;
        }
        if (this.carousel.currdeg < -this.carousel.maxDegree) {
            this.carousel.currdeg = -this.carousel.maxDegree;
        }
    };
    CarouselComponent.prototype.checkLimitsCarrousel = function (index) {
        return this.carousel.currentIndex != index && index >= 0 && index < this.carousel.totalItems;
    };
    CarouselComponent.prototype.moveSlideTo = function (index) {
        this.setNewDeg(-this.carousel.degreesSlides[index]);
        this.moveCarrousel(this.carousel.currdeg, this.timeToSlide);
    };
    CarouselComponent.prototype.moveCarrousel = function (deg, timeTransform) {
        if (timeTransform === void 0) { timeTransform = 0; }
        if (!this.carousel.lockSlides) {
            this.carouselElm.nativeElement.style.transition = "transform " + timeTransform + "ms";
            this.carouselElm.nativeElement.style.webkitTransition = "transform " + timeTransform + "ms";
            this.setTransformCarrousel(deg);
            this.detectCurrentSlide();
        }
    };
    CarouselComponent.prototype.setTransformCarrousel = function (deg) {
        this.carouselElm.nativeElement.style.transform = "rotateY(" + deg + "deg)";
        this.carouselElm.nativeElement.style.webkitTransform = "rotateY(" + deg + "deg)";
    };
    CarouselComponent.prototype.setPerspectiveContainer = function () {
        this.containerElm.nativeElement.style.perspective = this.perspective;
        this.containerElm.nativeElement.style.webkitPerspective = this.perspective;
    };
    CarouselComponent.prototype.getmaxSizes = function () {
        var _this = this;
        this.carousel.items.map(function (val) {
            var witdh = val.clientWidth;
            if (witdh > _this.carousel.maxSize) {
                _this.carousel.maxSize = witdh;
            }
        });
    };
    CarouselComponent.prototype.setDegreesOnSlides = function () {
        var _this = this;
        var auxDegree = 0;
        var scale = (1 + (this.carousel.maxSize * -1) / this.perspective) * this.ratioScale;
        var tz = (Math.round((this.carousel.maxSize / 2) /
            Math.tan(Math.PI / (360 / this.angle))) + this.margin) * scale;
        this.carousel.items.map(function (val, index) {
            val.style.width = _this.carousel.maxSize;
            val.style.transform = "rotateY(" + auxDegree + "deg) translateZ(" + (tz) + "px) scale(" + scale + ")";
            val.style.webkitTransform = "rotateY(" + auxDegree + "deg) translateZ(" + (tz) + "px) scale(" + scale + ")";
            _this.carousel.degreesSlides.push(auxDegree);
            _this.carousel.maxDegree = auxDegree;
            auxDegree += _this.angle;
        });
    };
    CarouselComponent.prototype.detectCurrentSlide = function () {
        var _this = this;
        var aux = 99e9;
        var index = 0;
        this.carousel.degreesSlides.forEach(function (val, i) {
            var res = Math.abs(val - Math.abs(_this.carousel.currdeg));
            if (res < aux) {
                aux = res;
                index = i;
            }
        });
        if (this.carousel.currentIndex != index) {
            this.carousel.lastIndex = this.carousel.currentIndex;
            this.carousel.currentIndex = index;
            this.updateCssShowSlides();
        }
    };
    CarouselComponent.prototype.updateCssShowSlides = function () {
        var vm = this;
        var currentIndex = vm.carousel.currentIndex;
        var actual = this.carousel.items[currentIndex];
        vm.removeClassShowSlides("actual");
        vm.removeClassShowSlides("prev");
        vm.removeClassShowSlides("next");
        if (actual) {
            actual.className += " actual";
        }
        for (var x = 0; x < this.morePairSlides; x++) {
            var prev = vm.carousel.items[currentIndex - (x + 1)];
            var next = vm.carousel.items[currentIndex + (x + 1)];
            if (prev) {
                prev.className += " prev";
            }
            if (next) {
                next.className += " next";
            }
        }
    };
    CarouselComponent.prototype.removeClassShowSlides = function (tagClass) {
        if (this.carouselElm.nativeElement.getElementsByClassName(tagClass).length > 1) {
            Array.from(this.carouselElm.nativeElement.getElementsByClassName(tagClass)).map(function (val) {
                val['classList'].remove(tagClass);
            });
        }
    };
    CarouselComponent.prototype.manageEvents = function () {
        var _this = this;
        var options = {
            preventDefault: true
        };
        var vm = this;
        var hammertime = new Hammer(this.carouselElm.nativeElement, options);
        hammertime.on("pan", function (e) {
            var elm = { carousel: vm.carousel, event: e };
            vm.onTouchMove.emit(elm);
            if (e.isFinal) {
                vm.onTouchEnd.emit(elm);
            }
            else if (e.isFirst) {
                vm.onSlideChangeStart.emit(elm);
                vm.onTouchStart.emit(elm);
                if (e.direction === Hammer.DIRECTION_LEFT) {
                    vm.onSlideNextStart.emit(elm);
                }
                else if (e.direction === Hammer.DIRECTION_RIGHT) {
                    vm.onSlidePrevStart.emit(elm);
                }
            }
        });
        this.carouselElm.nativeElement.addEventListener('transitionend', function (e) {
            var elm = { carousel: vm.carousel, event: e };
            if (e.propertyName === "transform") {
                _this.onTransitionEnd.emit(elm);
                _this.onSlideChangeEnd.emit(elm);
                if (vm.carousel.lastIndex > vm.carousel.currentIndex) {
                    _this.onSlideNextEnd.emit(elm);
                }
                else {
                    _this.onSlidePrevEnd.emit(elm);
                }
            }
        });
        this.carouselElm.nativeElement.addEventListener('transitionstart', function (ev) {
            console.log(ev);
        });
    };
    __decorate$1([
        _angular_core.Input("morePairSlides")
    ], CarouselComponent.prototype, "morePairSlides", void 0);
    __decorate$1([
        _angular_core.Input("angle")
    ], CarouselComponent.prototype, "angle", void 0);
    __decorate$1([
        _angular_core.Input("ratioScale")
    ], CarouselComponent.prototype, "ratioScale", void 0);
    __decorate$1([
        _angular_core.Input("margin")
    ], CarouselComponent.prototype, "margin", void 0);
    __decorate$1([
        _angular_core.Input("perspective")
    ], CarouselComponent.prototype, "perspective", void 0);
    __decorate$1([
        _angular_core.Input("endInSlide")
    ], CarouselComponent.prototype, "endInSlide", void 0);
    __decorate$1([
        _angular_core.Input("timeToSlide")
    ], CarouselComponent.prototype, "timeToSlide", void 0);
    __decorate$1([
        _angular_core.Input("lockSlides")
    ], CarouselComponent.prototype, "lockSlides", void 0);
    __decorate$1([
        _angular_core.Input("initialSlide")
    ], CarouselComponent.prototype, "initialSlide", void 0);
    __decorate$1([
        _angular_core.Output("onSlideChangeStart")
    ], CarouselComponent.prototype, "onSlideChangeStart", void 0);
    __decorate$1([
        _angular_core.Output("onSlideChangeEnd")
    ], CarouselComponent.prototype, "onSlideChangeEnd", void 0);
    __decorate$1([
        _angular_core.Output("onSlideNextStart")
    ], CarouselComponent.prototype, "onSlideNextStart", void 0);
    __decorate$1([
        _angular_core.Output("onSlideNextEnd")
    ], CarouselComponent.prototype, "onSlideNextEnd", void 0);
    __decorate$1([
        _angular_core.Output("onSlidePrevStart")
    ], CarouselComponent.prototype, "onSlidePrevStart", void 0);
    __decorate$1([
        _angular_core.Output("onSlidePrevEnd")
    ], CarouselComponent.prototype, "onSlidePrevEnd", void 0);
    __decorate$1([
        _angular_core.Output("onTouchMove")
    ], CarouselComponent.prototype, "onTouchMove", void 0);
    __decorate$1([
        _angular_core.Output("onTouchStart")
    ], CarouselComponent.prototype, "onTouchStart", void 0);
    __decorate$1([
        _angular_core.Output("onTouchEnd")
    ], CarouselComponent.prototype, "onTouchEnd", void 0);
    __decorate$1([
        _angular_core.Output("onTransitionStart")
    ], CarouselComponent.prototype, "onTransitionStart", void 0);
    __decorate$1([
        _angular_core.Output("onTransitionEnd")
    ], CarouselComponent.prototype, "onTransitionEnd", void 0);
    __decorate$1([
        _angular_core.ViewChild("carousel")
    ], CarouselComponent.prototype, "carouselElm", void 0);
    __decorate$1([
        _angular_core.ViewChild("container")
    ], CarouselComponent.prototype, "containerElm", void 0);
    CarouselComponent = __decorate$1([
        _angular_core.Component({
            selector: 'carousel-component',
            template: '<div class="container" #container>\n' +
                '  <div class="carousel" #carousel (pan)="rotate($event)">\n' +
                '    <!--<div class="item {{item.toLowerCase()}} {{updateCssShowSlides(i)}}" *ngFor="let item of data; let i = index">{{item}}</div>-->\n' +
                '    <ng-content select=".item-carousel"></ng-content>\n' +
                '  </div>\n' +
                '</div>',
        })
        // TODO: move chart.js to it's own component
    ], CarouselComponent);
    return CarouselComponent;
}());

/**
 * :tmtfactory) © 2017
 * Alex Marcos <alejandro.marcos@tmtfactory.com>
 * @ignore
 */
var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var MyHammerConfig = /** @class */ (function (_super) {
    __extends(MyHammerConfig, _super);
    function MyHammerConfig() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.overrides = {
            'swipe': { direction: Hammer.DIRECTION_ALL },
            'pan': { direction: Hammer.DIRECTION_HORIZONTAL } // override default settings
        };
        return _this;
    }
    return MyHammerConfig;
}(_angular_platformBrowser.HammerGestureConfig));
var CarouselModule = /** @class */ (function () {
    function CarouselModule() {
    }
    CarouselModule = __decorate([
        _angular_core.NgModule({
            imports: [_angular_common.CommonModule],
            declarations: [
                CarouselComponent
            ],
            providers: [
                {
                    provide: _angular_platformBrowser.HAMMER_GESTURE_CONFIG,
                    useClass: MyHammerConfig
                }
            ],
            exports: [CarouselComponent]
        })
    ], CarouselModule);
    return CarouselModule;
}());

/**
 * @module
 * @description
 * Entry point for all public APIs of the Angular Module
 */

exports.CarouselModule = CarouselModule;

Object.defineProperty(exports, '__esModule', { value: true });

})));
