/**
 * :tmtfactory) © 2017
 * Alex Marcos <alejandro.marcos@tmtfactory.com>
 * @ignore
 */
import { AfterViewInit, ElementRef, EventEmitter, OnInit } from '@angular/core';
import { Carousel } from "./Carousel";
export declare class CarouselComponent implements OnInit, AfterViewInit {
    carousel: Carousel;
    morePairSlides: number;
    angle: number;
    ratioScale: number;
    margin: number;
    perspective: number;
    endInSlide: boolean;
    timeToSlide: number;
    lockSlides: boolean;
    initialSlide: number;
    onSlideChangeStart: EventEmitter<{}>;
    onSlideChangeEnd: EventEmitter<{}>;
    onSlideNextStart: EventEmitter<{}>;
    onSlideNextEnd: EventEmitter<{}>;
    onSlidePrevStart: EventEmitter<{}>;
    onSlidePrevEnd: EventEmitter<{}>;
    onTouchMove: EventEmitter<{}>;
    onTouchStart: EventEmitter<{}>;
    onTouchEnd: EventEmitter<{}>;
    onTransitionStart: EventEmitter<{}>;
    onTransitionEnd: EventEmitter<{}>;
    carouselElm: ElementRef;
    containerElm: ElementRef;
    constructor();
    ngOnInit(): void;
    ngAfterViewInit(): void;
    slideNext(): void;
    slidePrev(): void;
    slideTo(index: any): void;
    update(): void;
    private configPlugin();
    private initSlidesOn();
    private rotate(e);
    private setNewDeg(newDeg);
    private checkLimitsCarrousel(index);
    private moveSlideTo(index);
    private moveCarrousel(deg, timeTransform?);
    private setTransformCarrousel(deg);
    private setPerspectiveContainer();
    private getmaxSizes();
    private setDegreesOnSlides();
    private detectCurrentSlide();
    private updateCssShowSlides();
    private removeClassShowSlides(tagClass);
    private manageEvents();
}
