var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
/**
 * :tmtfactory) © 2017
 * Alex Marcos <alejandro.marcos@tmtfactory.com>
 * @ignore
 */
import { Component, EventEmitter, Input, Output, ViewChild } from '@angular/core';
import * as Hammer from 'hammerjs';
import { Carousel } from "./Carousel";
var CarouselComponent = /** @class */ (function () {
    function CarouselComponent() {
        this.carousel = new Carousel();
        this.morePairSlides = 2;
        this.angle = 45;
        this.ratioScale = 1;
        this.margin = 20;
        this.perspective = 2000;
        this.endInSlide = true;
        this.timeToSlide = 300;
        this.lockSlides = false;
        this.initialSlide = 0;
        this.onSlideChangeStart = new EventEmitter();
        this.onSlideChangeEnd = new EventEmitter();
        this.onSlideNextStart = new EventEmitter();
        this.onSlideNextEnd = new EventEmitter();
        this.onSlidePrevStart = new EventEmitter();
        this.onSlidePrevEnd = new EventEmitter();
        this.onTouchMove = new EventEmitter();
        this.onTouchStart = new EventEmitter();
        this.onTouchEnd = new EventEmitter();
        this.onTransitionStart = new EventEmitter();
        this.onTransitionEnd = new EventEmitter();
    }
    CarouselComponent.prototype.ngOnInit = function () {
    };
    CarouselComponent.prototype.ngAfterViewInit = function () {
        this.configPlugin();
        console.log(this);
    };
    CarouselComponent.prototype.slideNext = function () {
        if (this.checkLimitsCarrousel(this.carousel.currentIndex + 1)) {
            this.moveSlideTo(++this.carousel.currentIndex);
        }
    };
    CarouselComponent.prototype.slidePrev = function () {
        if (this.checkLimitsCarrousel(this.carousel.currentIndex - 1)) {
            this.moveSlideTo(--this.carousel.currentIndex);
        }
    };
    CarouselComponent.prototype.slideTo = function (index) {
        if (this.checkLimitsCarrousel(index)) {
            this.carousel.currentIndex = index;
            this.moveSlideTo(this.carousel.currentIndex);
        }
    };
    CarouselComponent.prototype.update = function () {
        this.carousel = new Carousel;
        this.configPlugin();
    };
    CarouselComponent.prototype.configPlugin = function () {
        this.setPerspectiveContainer();
        this.carousel.items = Array.from(this.carouselElm.nativeElement.getElementsByClassName("item-carousel"));
        this.carousel.totalItems = this.carousel.items.length;
        this.getmaxSizes();
        this.carousel.totalWidth = this.carousel.items.length * this.carousel.maxSize;
        this.carousel.lockSlides = this.lockSlides;
        this.setDegreesOnSlides();
        this.manageEvents();
        this.initSlidesOn();
        this.updateCssShowSlides();
    };
    CarouselComponent.prototype.initSlidesOn = function () {
        if (this.initialSlide >= 0 && this.initialSlide < this.carousel.items.length) {
            this.carousel.currentIndex = this.initialSlide;
            var newDeg = this.carousel.currentIndex * this.angle;
            this.setNewDeg(-newDeg);
            this.setTransformCarrousel(-newDeg);
        }
    };
    CarouselComponent.prototype.rotate = function (e) {
        this.setNewDeg(this.carousel.currdeg + e.velocity);
        this.moveCarrousel(this.carousel.currdeg);
        if (e.isFinal) {
            if (this.endInSlide) {
                this.moveSlideTo(this.carousel.currentIndex);
            }
        }
    };
    CarouselComponent.prototype.setNewDeg = function (newDeg) {
        this.carousel.currdeg = newDeg;
        if (this.carousel.currdeg > 0) {
            this.carousel.currdeg = 0;
        }
        if (this.carousel.currdeg < -this.carousel.maxDegree) {
            this.carousel.currdeg = -this.carousel.maxDegree;
        }
    };
    CarouselComponent.prototype.checkLimitsCarrousel = function (index) {
        return this.carousel.currentIndex != index && index >= 0 && index < this.carousel.totalItems;
    };
    CarouselComponent.prototype.moveSlideTo = function (index) {
        this.setNewDeg(-this.carousel.degreesSlides[index]);
        this.moveCarrousel(this.carousel.currdeg, this.timeToSlide);
    };
    CarouselComponent.prototype.moveCarrousel = function (deg, timeTransform) {
        if (timeTransform === void 0) { timeTransform = 0; }
        if (!this.carousel.lockSlides) {
            this.carouselElm.nativeElement.style.transition = "transform " + timeTransform + "ms";
            this.carouselElm.nativeElement.style.webkitTransition = "transform " + timeTransform + "ms";
            this.setTransformCarrousel(deg);
            this.detectCurrentSlide();
        }
    };
    CarouselComponent.prototype.setTransformCarrousel = function (deg) {
        this.carouselElm.nativeElement.style.transform = "rotateY(" + deg + "deg)";
        this.carouselElm.nativeElement.style.webkitTransform = "rotateY(" + deg + "deg)";
    };
    CarouselComponent.prototype.setPerspectiveContainer = function () {
        this.containerElm.nativeElement.style.perspective = this.perspective;
        this.containerElm.nativeElement.style.webkitPerspective = this.perspective;
    };
    CarouselComponent.prototype.getmaxSizes = function () {
        var _this = this;
        this.carousel.items.map(function (val) {
            var witdh = val.clientWidth;
            if (witdh > _this.carousel.maxSize) {
                _this.carousel.maxSize = witdh;
            }
        });
    };
    CarouselComponent.prototype.setDegreesOnSlides = function () {
        var _this = this;
        var auxDegree = 0;
        var scale = (1 + (this.carousel.maxSize * -1) / this.perspective) * this.ratioScale;
        var tz = (Math.round((this.carousel.maxSize / 2) /
            Math.tan(Math.PI / (360 / this.angle))) + this.margin) * scale;
        this.carousel.items.map(function (val, index) {
            val.style.width = _this.carousel.maxSize;
            val.style.transform = "rotateY(" + auxDegree + "deg) translateZ(" + (tz) + "px) scale(" + scale + ")";
            val.style.webkitTransform = "rotateY(" + auxDegree + "deg) translateZ(" + (tz) + "px) scale(" + scale + ")";
            _this.carousel.degreesSlides.push(auxDegree);
            _this.carousel.maxDegree = auxDegree;
            auxDegree += _this.angle;
        });
    };
    CarouselComponent.prototype.detectCurrentSlide = function () {
        var _this = this;
        var aux = 99e9;
        var index = 0;
        this.carousel.degreesSlides.forEach(function (val, i) {
            var res = Math.abs(val - Math.abs(_this.carousel.currdeg));
            if (res < aux) {
                aux = res;
                index = i;
            }
        });
        if (this.carousel.currentIndex != index) {
            this.carousel.lastIndex = this.carousel.currentIndex;
            this.carousel.currentIndex = index;
            this.updateCssShowSlides();
        }
    };
    CarouselComponent.prototype.updateCssShowSlides = function () {
        var vm = this;
        var currentIndex = vm.carousel.currentIndex;
        var actual = this.carousel.items[currentIndex];
        vm.removeClassShowSlides("actual");
        vm.removeClassShowSlides("prev");
        vm.removeClassShowSlides("next");
        if (actual) {
            actual.className += " actual";
        }
        for (var x = 0; x < this.morePairSlides; x++) {
            var prev = vm.carousel.items[currentIndex - (x + 1)];
            var next = vm.carousel.items[currentIndex + (x + 1)];
            if (prev) {
                prev.className += " prev";
            }
            if (next) {
                next.className += " next";
            }
        }
    };
    CarouselComponent.prototype.removeClassShowSlides = function (tagClass) {
        if (this.carouselElm.nativeElement.getElementsByClassName(tagClass).length > 1) {
            Array.from(this.carouselElm.nativeElement.getElementsByClassName(tagClass)).map(function (val) {
                val['classList'].remove(tagClass);
            });
        }
    };
    CarouselComponent.prototype.manageEvents = function () {
        var _this = this;
        var options = {
            preventDefault: true
        };
        var vm = this;
        var hammertime = new Hammer(this.carouselElm.nativeElement, options);
        hammertime.on("pan", function (e) {
            var elm = { carousel: vm.carousel, event: e };
            vm.onTouchMove.emit(elm);
            if (e.isFinal) {
                vm.onTouchEnd.emit(elm);
            }
            else if (e.isFirst) {
                vm.onSlideChangeStart.emit(elm);
                vm.onTouchStart.emit(elm);
                if (e.direction === Hammer.DIRECTION_LEFT) {
                    vm.onSlideNextStart.emit(elm);
                }
                else if (e.direction === Hammer.DIRECTION_RIGHT) {
                    vm.onSlidePrevStart.emit(elm);
                }
            }
        });
        this.carouselElm.nativeElement.addEventListener('transitionend', function (e) {
            var elm = { carousel: vm.carousel, event: e };
            if (e.propertyName === "transform") {
                _this.onTransitionEnd.emit(elm);
                _this.onSlideChangeEnd.emit(elm);
                if (vm.carousel.lastIndex > vm.carousel.currentIndex) {
                    _this.onSlideNextEnd.emit(elm);
                }
                else {
                    _this.onSlidePrevEnd.emit(elm);
                }
            }
        });
        this.carouselElm.nativeElement.addEventListener('transitionstart', function (ev) {
            console.log(ev);
        });
    };
    __decorate([
        Input("morePairSlides")
    ], CarouselComponent.prototype, "morePairSlides", void 0);
    __decorate([
        Input("angle")
    ], CarouselComponent.prototype, "angle", void 0);
    __decorate([
        Input("ratioScale")
    ], CarouselComponent.prototype, "ratioScale", void 0);
    __decorate([
        Input("margin")
    ], CarouselComponent.prototype, "margin", void 0);
    __decorate([
        Input("perspective")
    ], CarouselComponent.prototype, "perspective", void 0);
    __decorate([
        Input("endInSlide")
    ], CarouselComponent.prototype, "endInSlide", void 0);
    __decorate([
        Input("timeToSlide")
    ], CarouselComponent.prototype, "timeToSlide", void 0);
    __decorate([
        Input("lockSlides")
    ], CarouselComponent.prototype, "lockSlides", void 0);
    __decorate([
        Input("initialSlide")
    ], CarouselComponent.prototype, "initialSlide", void 0);
    __decorate([
        Output("onSlideChangeStart")
    ], CarouselComponent.prototype, "onSlideChangeStart", void 0);
    __decorate([
        Output("onSlideChangeEnd")
    ], CarouselComponent.prototype, "onSlideChangeEnd", void 0);
    __decorate([
        Output("onSlideNextStart")
    ], CarouselComponent.prototype, "onSlideNextStart", void 0);
    __decorate([
        Output("onSlideNextEnd")
    ], CarouselComponent.prototype, "onSlideNextEnd", void 0);
    __decorate([
        Output("onSlidePrevStart")
    ], CarouselComponent.prototype, "onSlidePrevStart", void 0);
    __decorate([
        Output("onSlidePrevEnd")
    ], CarouselComponent.prototype, "onSlidePrevEnd", void 0);
    __decorate([
        Output("onTouchMove")
    ], CarouselComponent.prototype, "onTouchMove", void 0);
    __decorate([
        Output("onTouchStart")
    ], CarouselComponent.prototype, "onTouchStart", void 0);
    __decorate([
        Output("onTouchEnd")
    ], CarouselComponent.prototype, "onTouchEnd", void 0);
    __decorate([
        Output("onTransitionStart")
    ], CarouselComponent.prototype, "onTransitionStart", void 0);
    __decorate([
        Output("onTransitionEnd")
    ], CarouselComponent.prototype, "onTransitionEnd", void 0);
    __decorate([
        ViewChild("carousel")
    ], CarouselComponent.prototype, "carouselElm", void 0);
    __decorate([
        ViewChild("container")
    ], CarouselComponent.prototype, "containerElm", void 0);
    CarouselComponent = __decorate([
        Component({
            selector: 'carousel-component',
            template: '<div class="container" #container>\n' +
                '  <div class="carousel" #carousel (pan)="rotate($event)">\n' +
                '    <!--<div class="item {{item.toLowerCase()}} {{updateCssShowSlides(i)}}" *ngFor="let item of data; let i = index">{{item}}</div>-->\n' +
                '    <ng-content select=".item-carousel"></ng-content>\n' +
                '  </div>\n' +
                '</div>',
        })
        // TODO: move chart.js to it's own component
    ], CarouselComponent);
    return CarouselComponent;
}());
export { CarouselComponent };
//# sourceMappingURL=carousel.component.js.map